/// <reference types="../../@cosmic/bos-script" />
/// <reference types="../../@cosmic/bos-core" />
declare global {
    namespace $ {
        namespace kd.bos.olap.common{
            interface ImmutablePropertyBag_S {
            }
            type ImmutablePropertyBag_ST = any & $.java.util.Map & ImmutablePropertyBag_S;
            interface ImmutablePropertyBag_C extends ImmutablePropertyBag_ST {
                new():ImmutablePropertyBag;
                new(arg0:$.java.util.Map):ImmutablePropertyBag;
                new(arg0:$.java.util.Map,arg1:number,arg2:any):ImmutablePropertyBag;
            }
            interface ImmutablePropertyBag$ {
                compute(arg0:string,biFunc1:(t:any,u:any)=>any):string;
                computeIfAbsent(arg0:string,func1:(t:any)=>any):string;
                computeIfPresent(arg0:string,biFunc1:(t:any,u:any)=>any):string;
                contains(arg0:string):boolean;
                containsKey(arg0:string):boolean;
                containsValue(arg0:string):boolean;
                get(arg0:string):string;
                getCount():number;
                getEntries():$.java.util.Set;
                getKeys():$.java.util.Set;
                getSize():number;
                getValueOrNull(arg0:string):string;
                getValues():$.java.util.Collection;
                merge(arg0:string,arg1:string,biFunc2:(t:any,u:any)=>any):string;
                put(arg0:string,arg1:string):string;
                putIfAbsent(arg0:string,arg1:string):string;
                replace(arg0:string,arg1:string):string;
                replace(arg0:string,arg1:string,arg2:string):boolean;
            }
            type ImmutablePropertyBag_T = $.java.util.Map & any & ImmutablePropertyBag_S & ImmutablePropertyBag$;
            interface ImmutablePropertyBag extends ImmutablePropertyBag_T {
            }
            interface Version_S {
                readonly Companion:Version$Companion;
                access$getCurrentVersion$cp():Version;
            }
            type Version_ST = $.java.lang.Comparable & Version_S;
            interface Version_C extends Version_ST {
                new(arg0:number,arg1:number):Version;
                new(arg0:number,arg1:number,arg2:string,arg3:any):Version;
            }
            interface Version$ {
                compareTo(arg0:Version):number;
                getMajorVersion():number;
                getMinorVersion():number;
                getStringValue():string;
                isEmpty():boolean;
            }
            type Version_T = $.java.lang.Comparable & Version_S & Version$;
            interface Version extends Version_T {
            }
            interface PropertyBag_S {
                readonly Companion:PropertyBag$Companion;
            }
            type PropertyBag_ST = ImmutablePropertyBag_S & PropertyBag_S;
            interface PropertyBag_C extends PropertyBag_ST {
                new():PropertyBag;
                new(arg0:$.java.util.Map):PropertyBag;
                new(arg0:$.java.util.Map,arg1:number,arg2:any):PropertyBag;
            }
            interface PropertyBag$ {
                remove(arg0:string):boolean;
                set(arg0:string,arg1:string):void;
                setOrRemove(arg0:string,arg1:string):void;
            }
            type PropertyBag_T = ImmutablePropertyBag & PropertyBag_S & PropertyBag$;
            interface PropertyBag extends PropertyBag_T {
            }
            interface MembersKey_S {
            }
            interface MembersKey_C extends MembersKey_S {
                new(arg0:any[],arg1:kd.bos.olap.metadata.IMetadataBuilder):MembersKey;
            }
            interface MembersKey$ {
                clone():this;
                get(arg0:number):any;
                getCount():number;
                getKey(arg0:number):string;
                getSize():number;
            }
            type MembersKey_T = MembersKey_S & MembersKey$;
            interface MembersKey extends MembersKey_T {
            }
            interface PropertyBag$Companion_S {
                access$isPropertyName(arg0:PropertyBag$Companion,arg1:string):boolean;
            }
            interface PropertyBag$Companion_C extends PropertyBag$Companion_S {
                new(arg0:any):PropertyBag$Companion;
            }
            interface PropertyBag$Companion$ {
            }
            type PropertyBag$Companion_T = PropertyBag$Companion_S & PropertyBag$Companion$;
            interface PropertyBag$Companion extends PropertyBag$Companion_T {
            }
            interface Version$Companion_S {
                access$getCurVersion(arg0:Version$Companion):Version;
            }
            interface Version$Companion_C extends Version$Companion_S {
                new(arg0:any):Version$Companion;
            }
            interface Version$Companion$ {
                createVersion(arg0:string):Version;
                getCurrentVersion():Version;
                ifThen(arg0:Version,arg1:boolean,arg2:Version):Version;
                max(arg0:Version,arg1:Version):Version;
            }
            type Version$Companion_T = Version$Companion_S & Version$Companion$;
            interface Version$Companion extends Version$Companion_T {
            }
            interface CellSet_S {
                access$getValueMap$p(arg0:CellSet):$.java.util.Map;
            }
            interface CellSet_C extends CellSet_S {
                new(arg0:kd.bos.olap.dataSources.OlapDataReader):CellSet;
                new(arg0:string[],arg1:string[]):CellSet;
            }
            interface CellSet$ {
                Save(arg0:kd.bos.olap.dataSources.OlapDataWriter):void;
                get(arg0:any[]):any;
                get(arg0:MembersKey):any;
                get(arg0:string[],arg1:string):any;
                get(arg0:MembersKey,arg1:any):any;
                getCount():number;
                getMetricEntries(arg0:string):$.java.util.Iterator;
                getMutableMetricEntries(arg0:string):$.java.util.Iterator;
                isFromQuery():boolean;
                remove(arg0:any[]):boolean;
                remove(arg0:string[]):boolean;
                remove(arg0:MembersKey):boolean;
                set(arg0:any[],arg1:any):void;
                set(arg0:MembersKey,arg1:any):void;
                set(arg0:string[],arg1:string,arg2:any):void;
                set(arg0:MembersKey,arg1:any,arg2:any):void;
                set(arg0:MembersKey,arg1:any,arg2:boolean,arg3:any):void;
                setFromQuery(arg0:boolean):void;
            }
            type CellSet_T = CellSet_S & CellSet$;
            interface CellSet extends CellSet_T {
            }
        }
        namespace kd.bos.olap.dataSources{
            enum OrderBy {
                DESC,
                ASC
            }
            interface CustomFunction$Companion_S {
            }
            interface CustomFunction$Companion_C extends CustomFunction$Companion_S {
                new(arg0:any):CustomFunction$Companion;
            }
            interface CustomFunction$Companion$ {
                formatSpecialParam$bos_olap_client(arg0:string):string;
            }
            type CustomFunction$Companion_T = CustomFunction$Companion_S & CustomFunction$Companion$;
            interface CustomFunction$Companion extends CustomFunction$Companion_T {
            }
            interface IOlapDataReader_S {
            }
            interface IOlapDataReader$ {
                close():void;
                getFieldCount():number;
                getFieldName(arg0:number):string;
                getMetadataBuilder():kd.bos.olap.metadata.IMetadataBuilder;
                getMetadataType(arg0:number):kd.bos.olap.metadata.MetadataTypes;
                getValues(arg0:any[]):number;
                next():boolean;
            }
            type IOlapDataReader_T = IOlapDataReader_S & IOlapDataReader$;
            interface IOlapDataReader extends IOlapDataReader_T {
            }
            interface CustomFunction_S {
                readonly Companion:CustomFunction$Companion;
            }
            interface CustomFunction_C extends CustomFunction_S {
                new():CustomFunction;
            }
            interface CustomFunction$ {
                build$bos_olap_client():string;
                create$bos_olap_client():string;
                getFunVersion$bos_olap_client():kd.bos.olap.common.Version;
                getMaxVersion$bos_olap_client():kd.bos.olap.common.Version;
                getName$bos_olap_client():string;
                getParams$bos_olap_client():any[];
            }
            type CustomFunction_T = CustomFunction_S & CustomFunction$;
            interface CustomFunction extends CustomFunction_T {
            }
            enum DynamicCalcVersion {
                V1,
                V2
            }
            interface OlapDataReader_S {
            }
            type OlapDataReader_ST = $.java.io.Closeable & OlapDataReader_S;
            interface OlapDataReader_C extends OlapDataReader_ST {
                new(arg0:IOlapDataReader):OlapDataReader;
            }
            interface OlapDataReader$ {
                getFieldCount():number;
                getFieldName(arg0:number):string;
                getMetadataBuilder():kd.bos.olap.metadata.IMetadataBuilder;
                getMetadataType(arg0:number):kd.bos.olap.metadata.MetadataTypes;
                getValues(arg0:any[]):number;
                next():boolean;
            }
            type OlapDataReader_T = $.java.io.Closeable & OlapDataReader_S & OlapDataReader$;
            interface OlapDataReader extends OlapDataReader_T {
            }
            interface IOlapConnection_S {
            }
            interface IOlapConnection$ {
                Close():void;
                CreateCommand(arg0:CommandInfo):IOlapCommand;
                Open():void;
                clone(arg0:OlapConnectionStringBuilder):this;
                commit():void;
                createSandbox():$.java.io.Closeable;
                getPassword():string;
                getUserName():string;
                isClosed():boolean;
                isSandboxEnv():boolean;
                rollback():void;
                setAutoCommit(arg0:boolean):void;
                setPassword(arg0:string):void;
                setUserName(arg0:string):void;
            }
            type IOlapConnection_T = IOlapConnection_S & IOlapConnection$;
            interface IOlapConnection extends IOlapConnection_T {
            }
            interface IOlapCommand_S {
            }
            interface IOlapCommand$ {
                createWriter(arg0:kd.bos.olap.metadata.IMetadataBuilder):IOlapDataWriter;
                executeBackup():void;
                executeCellSet(arg0:kd.bos.olap.metadata.IMetadataBuilder):kd.bos.olap.common.CellSet;
                executeCompute():void;
                executeFunction():kd.bos.olap.common.PropertyBag;
                executeNonQuery():void;
                executeReader(arg0:kd.bos.olap.metadata.IMetadataBuilder):IOlapDataReader;
                executeRecovery():void;
                updateMetadata():void;
            }
            type IOlapCommand_T = IOlapCommand_S & IOlapCommand$;
            interface IOlapCommand extends IOlapCommand_T {
            }
            interface OlapDataWriter_S {
            }
            type OlapDataWriter_ST = $.java.io.Closeable & OlapDataWriter_S;
            interface OlapDataWriter_C extends OlapDataWriter_ST {
                new(arg0:IOlapDataWriter):OlapDataWriter;
            }
            interface OlapDataWriter$ {
                flush():void;
                getFieldCount():number;
                getFieldName(arg0:number):string;
                getMetadataType(arg0:number):kd.bos.olap.metadata.MetadataTypes;
                setValues(arg0:any[]):void;
            }
            type OlapDataWriter_T = $.java.io.Closeable & OlapDataWriter_S & OlapDataWriter$;
            interface OlapDataWriter extends OlapDataWriter_T {
            }
            interface CommandInfo_S {
            }
            type CommandInfo_ST = $.java.io.Serializable & CommandInfo_S;
            interface CommandInfo_C extends CommandInfo_ST {
                new():CommandInfo;
            }
            interface CommandInfo$ {
                getExtProperties():$.java.util.Map;
                getMinServerVersion$bos_olap_client():kd.bos.olap.common.Version;
                getMinServerVersion$bos_olap_client(arg0:IOlapConnection):kd.bos.olap.common.Version;
                setExtProperties(arg0:$.java.util.Map):void;
            }
            type CommandInfo_T = $.java.io.Serializable & CommandInfo_S & CommandInfo$;
            interface CommandInfo extends CommandInfo_T {
            }
            interface OrderByItem_S {
            }
            interface OrderByItem_C extends OrderByItem_S {
                new(arg0:string,arg1:OrderBy):OrderByItem;
            }
            interface OrderByItem$ {
                getName():string;
                getType():OrderBy;
            }
            type OrderByItem_T = OrderByItem_S & OrderByItem$;
            interface OrderByItem extends OrderByItem_T {
            }
            interface OlapConnectionStringBuilder_S {
                getTimeout$annotations():void;
            }
            type OlapConnectionStringBuilder_ST = kd.bos.olap.common.PropertyBag_S & OlapConnectionStringBuilder_S;
            interface OlapConnectionStringBuilder_C extends OlapConnectionStringBuilder_ST {
                new():OlapConnectionStringBuilder;
                new(arg0:string):OlapConnectionStringBuilder;
                new(arg0:string,arg1:number,arg2:any):OlapConnectionStringBuilder;
            }
            interface OlapConnectionStringBuilder$ {
                clone$bos_olap_client():this;
                getApplicationName():string;
                getClientVersion$bos_olap_client():string;
                getConnectTimeout():number;
                getConnectionString():string;
                getDataSource():string;
                getForTest():string;
                getInitialCatalog():string;
                getLanguage():string;
                getNestedOpenClose():boolean;
                getPersistentSandboxName():string;
                getProvider():string;
                getReadTimeout():number;
                getTenantId():string;
                getTimeout():number;
                setApplicationName(arg0:string):void;
                setConnectTimeout(arg0:number):void;
                setConnectionString(arg0:string):void;
                setDataSource(arg0:string):void;
                setForTest(arg0:string):void;
                setInitialCatalog(arg0:string):void;
                setLanguage(arg0:string):void;
                setNestedOpenClose(arg0:boolean):void;
                setPersistentSandboxName(arg0:string):void;
                setProvider(arg0:string):void;
                setReadTimeout(arg0:number):void;
                setTenantId(arg0:string):void;
                setTimeout(arg0:number):void;
            }
            type OlapConnectionStringBuilder_T = kd.bos.olap.common.PropertyBag & OlapConnectionStringBuilder_S & OlapConnectionStringBuilder$;
            interface OlapConnectionStringBuilder extends OlapConnectionStringBuilder_T {
            }
            interface SelectCommandInfo_S {
            }
            type SelectCommandInfo_ST = IPSandboxCommand_S & CommandInfo_S & SelectCommandInfo_S;
            interface SelectCommandInfo_C extends SelectCommandInfo_ST {
                new():SelectCommandInfo;
                new(arg0:$.java.util.List,arg1:$.java.util.List,arg2:$.java.util.List):SelectCommandInfo;
            }
            interface SelectCommandInfo$ {
                addCustomFunction(arg0:string,arg1:CustomFunction):this;
                addDims(...arg0:string[]):this;
                addFilter(arg0:string,...arg1:string[]):this;
                addMeasures(...arg0:string[]):this;
                addOrderByItem(...arg0:OrderByItem[]):this;
                getDimensions():$.java.util.List;
                getDynamicCalcVersion():DynamicCalcVersion;
                getExcludeDynamicCalcResult():boolean;
                getExcludeNull():boolean;
                getExcludeNullOrDefault():boolean;
                getFilter():$.java.util.List;
                getIncludeDynamicMemberWhenNullFilter():boolean;
                getMeasureFilter():string;
                getMeasures():$.java.util.List;
                getOrderBy():$.java.util.List;
                getTop():number;
                setDimensions(arg0:$.java.util.List):void;
                setDynamicCalcVersion(arg0:DynamicCalcVersion):void;
                setExcludeDynamicCalcResult(arg0:boolean):void;
                setExcludeNull(arg0:boolean):void;
                setExcludeNullOrDefault(arg0:boolean):void;
                setFilter(arg0:$.java.util.List):void;
                setIncludeDynamicMemberWhenNullFilter(arg0:boolean):void;
                setMeasureFilter(arg0:string):void;
                setMeasures(arg0:$.java.util.List):void;
                setTop(arg0:number):void;
            }
            type SelectCommandInfo_T = CommandInfo & IPSandboxCommand & SelectCommandInfo_S & SelectCommandInfo$;
            interface SelectCommandInfo extends SelectCommandInfo_T {
            }
            interface IOlapDataWriter_S {
            }
            interface IOlapDataWriter$ {
                flush():void;
                getFieldCount():number;
                getFieldName(arg0:number):string;
                getMetadataType(arg0:number):kd.bos.olap.metadata.MetadataTypes;
                setValues(arg0:any[]):void;
            }
            type IOlapDataWriter_T = $.java.io.Closeable & IOlapDataWriter_S & IOlapDataWriter$;
            interface IOlapDataWriter extends IOlapDataWriter_T {
            }
            interface IPSandboxCommand_S {
            }
            interface IPSandboxCommand$ {
                copyAndConvert(arg0:string):CommandInfo;
            }
            type IPSandboxCommand_T = IPSandboxCommand_S & IPSandboxCommand$;
            interface IPSandboxCommand extends IPSandboxCommand_T {
            }
        }
        namespace kd.bos.olap.metadata{
            interface IMetadataBuilder_S {
            }
            interface IMetadataBuilder$ {
                getDimension(arg0:string):any;
                getMeasure(arg0:string):any;
                getMember(arg0:any,arg1:string):any;
                getNumber(arg0:any):string;
            }
            type IMetadataBuilder_T = IMetadataBuilder_S & IMetadataBuilder$;
            interface IMetadataBuilder extends IMetadataBuilder_T {
            }
            enum MetadataTypes {
                Unknown,
                Cube,
                Dimension,
                Hierarchy,
                Level,
                Measure,
                Member,
                Enums,
                EnumMember,
                Partition,
                AggFactor,
                AggShieldRule,
                ValidDataRule,
                Sandbox,
                PiecewiseExpression,
                CubeDataScope,
                CubeLockRule,
                Tag,
                SimpleMember
            }
        }
        namespace kd.sdk.epm.bgmd.common{
            interface SdkClassUtils_S {
                invokeStaticMethod(clazzName:string,methodName:string,...args:any[]):any;
            }
            interface SdkClassUtils_C extends SdkClassUtils_S {
                new():SdkClassUtils;
            }
            interface SdkClassUtils$ {
            }
            type SdkClassUtils_T = SdkClassUtils_S & SdkClassUtils$;
            interface SdkClassUtils extends SdkClassUtils_T {
            }
        }
        namespace kd.sdk.epm.bgmd.constants{
            interface FacTabFieldDefFields_S {
                readonly FIELD_MONEY:string;
                readonly FIELD_STATUS:string;
            }
            interface FacTabFieldDefFields_C extends FacTabFieldDefFields_S {
                new():FacTabFieldDefFields;
            }
            interface FacTabFieldDefFields$ {
            }
            type FacTabFieldDefFields_T = FacTabFieldDefFields_S & FacTabFieldDefFields$;
            interface FacTabFieldDefFields extends FacTabFieldDefFields_T {
            }
            interface BgControlSettingTypeNumbers_S {
                readonly HALFYEAR:string;
                readonly HALFYEAR_ADDUP:string;
                readonly MONTH:string;
                readonly MONTH_ADDUP:string;
                readonly MONTH_BY_YEAR_CURR_GROSS:string;
                readonly MONTH_HALFYEAR_ADDUP:string;
                readonly MONTH_MODEL_ADDUP:string;
                readonly MONTH_QUARTER_ADDUP:string;
                readonly QUARTER:string;
                readonly QUARTER_ADDUP:string;
                readonly QUARTER_HALFYEAR_ADDUP:string;
                readonly QUARTER_MODEL_ADDUP:string;
                readonly YEAR:string;
                readonly YEAR_MODEL_ADDIP:string;
            }
            interface BgControlSettingTypeNumbers_C extends BgControlSettingTypeNumbers_S {
                new():BgControlSettingTypeNumbers;
            }
            interface BgControlSettingTypeNumbers$ {
            }
            type BgControlSettingTypeNumbers_T = BgControlSettingTypeNumbers_S & BgControlSettingTypeNumbers$;
            interface BgControlSettingTypeNumbers extends BgControlSettingTypeNumbers_T {
            }
        }
        namespace kd.sdk.epm.bgmd.enums.formplugin.api{
            enum SysDimensionEnum {
                Entity,
                Account,
                Year,
                Period,
                BudgetPeriod,
                Version,
                Currency,
                DataType,
                ChangeType,
                AuditTrail,
                Metric,
                InternalCompany,
                Project,
                Scenario,
                Process,
                Sandbox
            }
            enum ReturnAndCloseEnum {
                SUCCESS,
                FAIL
            }
        }
        namespace kd.sdk.epm.bgmd.formplugin{
            interface IBgmdFormPlugin_S {
                isDatasource(entityNumber:string):boolean;
            }
            interface IBgmdFormPlugin$ {
                /**
                 * @see kd.epm.eb.formplugin.AbstractFormPlugin
                 * @param operate
                 * @param dimNum
                 * @param memberNum
                 * @param viewId
                 * @return
                 */
                checkDimPermission?(operate:string,dimNum:string,memberNum:string,viewId:long):boolean;
                /**
                 * @see kd.epm.eb.common.permission.EBPermission
                 * @param userId
                 * @param dimObjId
                 * @param appId
                 * @param entityNumber
                 * @param permItemId
                 * @return
                 */
                checkItemPermission?(userId:long,dimObjId:long,appId:string,entityNumber:string,permItemId:string):number;
                /**
                 * @see kd.epm.eb.common.permission.EBPermission
                 * @param view
                 * @param permKey
                 */
                checkPermission?(permKey:string):void;
                /**
                 * @see kd.epm.eb.common.permission.EBPermission
                 * @param e
                 */
                checkViewPermPreOpen?(e:$.kd.bos.form.events.PreOpenFormEventArgs):void;
                doEBCheckPermission(userId:long,entityNumber:string,permItemId:string,permItemDesc:string):void;
                doEBCheckPermission(modelId:long,userId:long,appId:string,entityNumber:string,permItemId:string,permItemDesc:string):void;
                /**
                 * 描述：获取当前页面控权的应用id
                 * @return
                 */
                getBizAppId?():string;
                /**
                 * @see kd.epm.eb.common.permission.EBPermission
                 * @return
                 */
                getBizAppId4BGRP?():string;
                getModelId():long;
                getView():$.kd.bos.form.IFormView;
                /**
                 * @see kd.epm.eb.model.permission.MemberPermHelper
                 * @param userId
                 * @param modelId
                 * @return
                 */
                ifUserHasRootPermByModel?(userId:long,modelId:long):boolean;
                /**
                 * 描述：是否验证体系权限
                 */
                isCheckModel?():boolean;
            }
            type IBgmdFormPlugin_T = IBgmdFormPlugin_S & IBgmdFormPlugin$;
            interface IBgmdFormPlugin extends IBgmdFormPlugin_T {
            }
            interface AbstractBgmdFormPlugin_S {
            }
            type AbstractBgmdFormPlugin_ST = $.kd.bos.form.events.HyperLinkClickListener & $.kd.bos.form.plugin.AbstractFormPlugin & IBgmdFormPlugin_S & AbstractBgmdFormPlugin_S;
            interface AbstractBgmdFormPlugin_C extends AbstractBgmdFormPlugin_ST {
                new():AbstractBgmdFormPlugin;
            }
            interface AbstractBgmdFormPlugin$ {
            }
            type AbstractBgmdFormPlugin_T = $.kd.bos.form.plugin.AbstractFormPlugin & IBgmdFormPlugin & $.kd.bos.form.events.HyperLinkClickListener & AbstractBgmdFormPlugin_S & AbstractBgmdFormPlugin$;
            interface AbstractBgmdFormPlugin extends AbstractBgmdFormPlugin_T {
            }
        }
        namespace kd.sdk.epm.bgmd.formplugin.permission{
            interface AbstractCusPermPlugin_S {
            }
            type AbstractCusPermPlugin_ST = SDKPermission_S & $.kd.bos.form.events.HyperLinkClickListener & $.kd.bos.form.plugin.AbstractFormPlugin & AbstractCusPermPlugin_S;
            interface AbstractCusPermPlugin_C extends AbstractCusPermPlugin_ST {
                new():AbstractCusPermPlugin;
            }
            interface AbstractCusPermPlugin$ {
            }
            type AbstractCusPermPlugin_T = $.kd.bos.form.plugin.AbstractFormPlugin & SDKPermission & $.kd.bos.form.events.HyperLinkClickListener & AbstractCusPermPlugin_S & AbstractCusPermPlugin$;
            interface AbstractCusPermPlugin extends AbstractCusPermPlugin_T {
            }
            interface SDKPermission_S {
                readonly FORM_MODEL:string;
                readonly log:$.kd.bos.logging.Log;
                readonly loggerv:$.kd.bos.logging.Log;
                readonly rootForms:$.java.util.List;
                readonly wfApps:$.java.util.List;
            }
            interface SDKPermission$ {
                checkItemPermission?(userId:long,dimObjId:long,appId:string,entityNumber:string,permItemId:string):number;
                /**
                 * 描述：权限检查接口
                 */
                checkPermission(source:string,permKey:string):void;
                /**
                 * 描述：权限检查接口
                 */
                checkPermission(view:$.kd.bos.form.IFormView,permKey:string):void;
                checkPermission(modelId:long,userId:long,appId:string,source:string,permKey:string):void;
                checkViewPermPreOpen?(e:$.kd.bos.form.events.PreOpenFormEventArgs):void;
                doEBCheckPermission(entityNumber:string,permItemId:string,permItemDesc:string):void;
                doEBCheckPermission(modelId:long,userId:long,appId:string,entityNumber:string,permItemId:string,permItemDesc:string):void;
                getAppIdFromMsgCentral?(appId:string,modelId:long):string;
                getBGRPSpecialEntity?():string;
                /**
                 * 描述：获取当前页面控权的应用id
                 */
                getBizAppId():string;
                getBizAppId4BGRP?():string;
                /**
                 * 兼容二开的布局页面，根据传入的二开页面标识获取原页面标识
                 *
                 * @param entityId 传入的页面标识
                 * @return 转换后的页面标识
                 */
                getEntityNumber?(entityId:string):string;
                getModelCustomKey?():string;
                /**
                 * 描述：返回体系id
                 */
                getModelId():long;
                getModelType?(dimObjId:long):string;
                /**
                 * 描述：返回
                 */
                getPermissionUtils?():SDKPermissionUtils;
                /**
                 * 针对工作流跳转到的预算页面，做验权时，获取真正控权的应用，这里是没法检查是否预算申报的，只能通过体系判断是否新费用预算
                 * @param modelId
                 * @return
                 */
                getRealAppId?(modelId:long):string;
                getSpecAppId?():string;
                /**
                 * 描述：返回当前用户id
                 */
                getUserId?():long;
                getView():$.kd.bos.form.IFormView;
                /**
                 * 判断某用户有没有某体系管理权限
                 *
                 * @param userId  用户id
                 * @param modelId 体系id
                 * @author rd_qiheng_chen
                 */
                ifUserHasRootPermByModel?(userId:long,modelId:long):boolean;
                ignoreSpecialPermCheck?(formShowParameter:$.kd.bos.form.FormShowParameter):void;
                /**
                 * 描述：是否验证体系权限
                 */
                isCheckModel():boolean;
                /**
                 * 判断某用户有没有某体系管理权限
                 * @author rd_qiheng_chen
                 * @param userId 用户id
                 * @param modelId 体系id
                 */
                isUserHasRootPermByModel?(userId:long,modelId:long):boolean;
                needCheckViewPerm?():boolean;
                notCheckPermInWorkFlow?():boolean;
            }
            type SDKPermission_T = SDKPermission_S & SDKPermission$;
            interface SDKPermission extends SDKPermission_T {
            }
            interface SDKPermissionUtils_S {
                getInstance():SDKPermissionUtils;
            }
            interface SDKPermissionUtils_C extends SDKPermissionUtils_S {
                new():SDKPermissionUtils;
            }
            interface SDKPermissionUtils$ {
                getFuncPermItems():$.java.util.Map;
                getPermItem():this;
                getPermItemsMap():$.java.util.Map;
            }
            type SDKPermissionUtils_T = SDKPermissionUtils_S & SDKPermissionUtils$;
            interface SDKPermissionUtils extends SDKPermissionUtils_T {
            }
        }
        namespace kd.sdk.epm.bgmd.util.base{
            interface AbstractUtils_S {
            }
            interface AbstractUtils_C extends AbstractUtils_S {
                new():AbstractUtils;
            }
            interface AbstractUtils$ {
            }
            type AbstractUtils_T = AbstractUtils_S & AbstractUtils$;
            interface AbstractUtils extends AbstractUtils_T {
            }
        }
        namespace kd.sdk.epm.bgmd.util.f7{
            interface F7Utils_S {
                readonly log:$.kd.bos.logging.Log;
                get():F7Utils;
            }
            type F7Utils_ST = kd.sdk.epm.bgmd.util.f7.impl.AbstractUtils_S & kd.sdk.epm.bgmd.util.f7.face.IF7_S & F7Utils_S;
            interface F7Utils_C extends F7Utils_ST {
                new():F7Utils;
            }
            interface F7Utils$ {
            }
            type F7Utils_T = kd.sdk.epm.bgmd.util.f7.impl.AbstractUtils & kd.sdk.epm.bgmd.util.f7.face.IF7 & F7Utils_S & F7Utils$;
            interface F7Utils extends F7Utils_T {
            }
            interface F8Utils_S {
                readonly log:$.kd.bos.logging.Log;
                get():F8Utils;
            }
            type F8Utils_ST = kd.sdk.epm.bgmd.util.f7.impl.AbstractUtils_S & kd.sdk.epm.bgmd.util.f7.face.IF8_S & F8Utils_S;
            interface F8Utils_C extends F8Utils_ST {
                new():F8Utils;
            }
            interface F8Utils$ {
            }
            type F8Utils_T = kd.sdk.epm.bgmd.util.f7.impl.AbstractUtils & kd.sdk.epm.bgmd.util.f7.face.IF8 & F8Utils_S & F8Utils$;
            interface F8Utils extends F8Utils_T {
            }
            interface F7Parameter_S {
            }
            interface F7Parameter_C extends F7Parameter_S {
                new():F7Parameter;
            }
            interface F7Parameter$ {
                getBusModelId():long;
                getCusRange():$.java.util.List;
                getDatasetIds():$.java.util.List;
                getDimensionId():long;
                getFilters():$.java.util.List;
                getModelId():long;
                getRangeType():number;
                getSelectIds():$.java.util.Map;
                isCanSelectRoot():boolean;
                isMultiSelect():boolean;
                isOnlySelLeaf():boolean;
                isVerifyPermission():boolean;
                setBusModelId(busModelId:long):void;
                setCanSelectRoot(canSelectRoot:boolean):void;
                setCusRange(cusRange:$.java.util.List):void;
                setDatasetIds(datasetIds:$.java.util.List):void;
                setDimensionId(dimensionId:long):void;
                setFilters(filters:$.java.util.List):void;
                setModelId(modelId:long):void;
                setMultiSelect(multiSelect:boolean):void;
                setOnlySelLeaf(onlySelLeaf:boolean):void;
                setRangeType(rangeType:number):void;
                setSelectIds(selectIds:$.java.util.Map):void;
                setVerifyPermission(verifyPermission:boolean):void;
            }
            type F7Parameter_T = F7Parameter_S & F7Parameter$;
            interface F7Parameter extends F7Parameter_T {
            }
        }
        namespace kd.sdk.epm.bgmd.util.f7.face{
            interface IF8_S {
            }
            interface IF8$ {
                /**
                 * 描述：打开一个维度成员范围选择界面
                 * @param evt BeforeF7SelectEvent
                 * @param closeCallBack 回调参数
                 * @param f7Param f7参数
                 */
                openF8(evt:$.kd.bos.form.field.events.BeforeF7SelectEvent,closeCallBack:$.kd.bos.form.CloseCallBack,f7Param:F7Parameter):void;
                /**
                 * 描述：打开一个维度成员范围选择界面
                 * @param view formView
                 * @param closeCallBack 回调参数
                 * @param f7Param f7参数
                 */
                openF8(view:$.kd.bos.form.IFormView,closeCallBack:$.kd.bos.form.CloseCallBack,f7Param:F7Parameter):void;
            }
            type IF8_T = IF8_S & IF8$;
            interface IF8 extends IF8_T {
            }
            interface IF7_S {
            }
            interface IF7$ {
                /**
                 * 描述：打开一个单选或者多选的维度成员界面
                 * @param evt BeforeF7SelectEvent
                 * @param closeCallBack 回调参数
                 * @param f7Param f7参数
                 */
                openF7(evt:$.kd.bos.form.field.events.BeforeF7SelectEvent,closeCallBack:$.kd.bos.form.CloseCallBack,f7Param:F7Parameter):void;
                /**
                 * 描述：打开一个单选或者多选的维度成员界面
                 * @param view IFormView
                 * @param closeCallBack 回调参数
                 * @param f7Param f7参数
                 */
                openF7(view:$.kd.bos.form.IFormView,closeCallBack:$.kd.bos.form.CloseCallBack,f7Param:F7Parameter):void;
                /**
                 * 打开f7
                 * @param evt f7打开事件
                 * @param modelId 体系id
                 * @param dimensionNumber 维度编码
                 * @param isMultipleF7 是否多选
                 * @param returnClassName 回调类名
                 */
                openF7(evt:$.kd.bos.form.field.events.BeforeF7SelectEvent,modelId:long,dimensionNumber:string,isMultipleF7:boolean,returnClassName:string):void;
            }
            type IF7_T = IF7_S & IF7$;
            interface IF7 extends IF7_T {
            }
        }
        namespace kd.sdk.epm.bgmd.util.f7.impl{
            interface AbstractUtils_S {
            }
            interface AbstractUtils_C extends AbstractUtils_S {
                new():AbstractUtils;
            }
            interface AbstractUtils$ {
                getDefault(modelId:long,dimensionId:long,busModelId:long,datasetIds:$.java.util.List):F7Parameter;
                getDefault(modelId:long,dimensionNumber:string,busModelId:long,datasetIds:$.java.util.List):F7Parameter;
            }
            type AbstractUtils_T = AbstractUtils_S & AbstractUtils$;
            interface AbstractUtils extends AbstractUtils_T {
            }
        }
        namespace kd.sdk.epm.bgmd.util.model{
            interface BusinessModelUtils_S {
                readonly BUSINESS_MODEL_ENTITY:string;
                readonly BUSINESS_MODEL_FIELDS:string;
                readonly BUSINESS_MODEL_FIELDS_DIMS:string;
                /**
                 * 根据数据集id获取业务模型id
                 * @param datasetId
                 * @return
                 */
                getBizModelByDataset(datasetId:long):long;
                getBusModel(busModelId:long,fields:string):$.kd.bos.dataentity.entity.DynamicObject;
                getBusModel(modelId:long,busModelNumber:string,fields:string):$.kd.bos.dataentity.entity.DynamicObject;
                getBusModels(modelId:long,fields:string):$.kd.bos.dataentity.entity.DynamicObjectCollection;
            }
            type BusinessModelUtils_ST = kd.sdk.epm.bgmd.util.base.AbstractUtils_S & BusinessModelUtils_S;
            interface BusinessModelUtils_C extends BusinessModelUtils_ST {
                new():BusinessModelUtils;
            }
            interface BusinessModelUtils$ {
            }
            type BusinessModelUtils_T = kd.sdk.epm.bgmd.util.base.AbstractUtils & BusinessModelUtils_S & BusinessModelUtils$;
            interface BusinessModelUtils extends BusinessModelUtils_T {
            }
            interface DimensionUtils_S {
                readonly DIMENSION_ENTITY:string;
                readonly DIMENSION_FIELDS:string;
                /**
                 * 描述：返回指定编码的维度对象
                 * @param modelId 体系id
                 * @param dimensionNumber 维度编码
                 * @return 维度对象
                 * @Date：2023/7/6
                 * @version：1.0
                 * @Description：返回指定编码的维度对象
                 */
                getDimension(modelId:long,dimensionNumber:string):$.kd.bos.dataentity.entity.DynamicObject;
                /**
                 * 描述：根据预算体系id及维度id返回维度对象
                 * @param modelId 体系id
                 * @param dimensionId 维度Id
                 * @param fields 维度属性字段
                 * @return 维度对象
                 * @Date：2023/7/6
                 * @version：1.0
                 * @Description：根据预算体系id及维度id返回维度对象
                 */
                getDimension(modelId:long,dimensionId:long,fields:string):$.kd.bos.dataentity.entity.DynamicObject;
                /**
                 * 描述：返回指定编码的维度对象
                 * @param modelId 体系id
                 * @param dimensionNumber 维度编码
                 * @param fields 维度属性字段
                 * @return 维度对象
                 * @Date：2023/7/6
                 * @version：1.0
                 * @Description：返回指定编码的维度对象
                 */
                getDimension(modelId:long,dimensionNumber:string,fields:string):$.kd.bos.dataentity.entity.DynamicObject;
                /**
                 * 描述：返回指定编码的维度id（如果查询不到维度则返回null）
                 * @param modelId 体系id
                 * @param dimensionNumber 维度编码
                 * @return 维度id
                 * @Date：2023/7/6
                 * @version：1.0
                 * @Description：根据体系id及维度编码返回维度id
                 */
                getDimensionId(modelId:long,dimensionNumber:string):long;
            }
            type DimensionUtils_ST = kd.sdk.epm.bgmd.util.base.AbstractUtils_S & DimensionUtils_S;
            interface DimensionUtils_C extends DimensionUtils_ST {
                new():DimensionUtils;
            }
            interface DimensionUtils$ {
            }
            type DimensionUtils_T = kd.sdk.epm.bgmd.util.base.AbstractUtils & DimensionUtils_S & DimensionUtils$;
            interface DimensionUtils extends DimensionUtils_T {
            }
            interface DatasetUtils_S {
                readonly DATASET_ENTITY:string;
                readonly DATASET_FIELDS:string;
                getDataset(datasetId:long,fields:string):$.kd.bos.dataentity.entity.DynamicObject;
                getDatasets(modelId:long,busModelId:long,fields:string):$.kd.bos.dataentity.entity.DynamicObjectCollection;
            }
            type DatasetUtils_ST = kd.sdk.epm.bgmd.util.base.AbstractUtils_S & DatasetUtils_S;
            interface DatasetUtils_C extends DatasetUtils_ST {
                new():DatasetUtils;
            }
            interface DatasetUtils$ {
            }
            type DatasetUtils_T = kd.sdk.epm.bgmd.util.base.AbstractUtils & DatasetUtils_S & DatasetUtils$;
            interface DatasetUtils extends DatasetUtils_T {
            }
            interface MemberUtils_S {
                readonly MEMBER_FIELDS:string;
                /**
                 * 描述：根据预算体系Id、维度Id，维度成员编码返回维度成员对象（最大返回5000个维度成员）
                 * @param modelId 预算体系Id
                 * @param dimensionId 维度Id
                 * @param memberNumbers 维度成员编码
                 * @param fields 维度成员属性字段
                 * @return 维度成员对象
                 */
                getMembers(modelId:long,dimensionId:long,memberNumbers:$.java.util.Collection,fields:string):$.kd.bos.dataentity.entity.DynamicObjectCollection;
            }
            type MemberUtils_ST = kd.sdk.epm.bgmd.util.base.AbstractUtils_S & MemberUtils_S;
            interface MemberUtils_C extends MemberUtils_ST {
                new():MemberUtils;
            }
            interface MemberUtils$ {
            }
            type MemberUtils_T = kd.sdk.epm.bgmd.util.base.AbstractUtils & MemberUtils_S & MemberUtils$;
            interface MemberUtils extends MemberUtils_T {
            }
            interface CubeUtils_S {
                readonly MODEL_ENTITY:string;
                readonly MODEL_FIELDS:string;
                readonly log:$.kd.bos.logging.Log;
                /**
                 * 描述：根据预算体系编码返回预算体系对象
                 * @param modelNumbers 预算体系编码
                 * @return 预算体系对象
                 * @Date：2023/7/6
                 * @version：1.0
                 * @Description：预算体系对象
                 */
                getModel(...modelNumbers:string[]):$.kd.bos.dataentity.entity.DynamicObjectCollection;
                /**
                 * 描述：根据预算体系Id返回预算模型对象
                 * @param modelId 预算体系Id
                 * @return 预算体系对象
                 * @Date：2023/7/6
                 * @version：1.0
                 * @Description：预算体系对象
                 */
                getModel(modelId:long,fields:string):$.kd.bos.dataentity.entity.DynamicObject;
                /**
                 * 描述：根据用户返回有权限的体系集合
                 * @param userNumber 用户编码
                 * @return 体系集合
                 */
                getModels(fields:string,userNumber:string):$.kd.bos.dataentity.entity.DynamicObjectCollection;
            }
            type CubeUtils_ST = kd.sdk.epm.bgmd.util.base.AbstractUtils_S & CubeUtils_S;
            interface CubeUtils_C extends CubeUtils_ST {
                new():CubeUtils;
            }
            interface CubeUtils$ {
            }
            type CubeUtils_T = kd.sdk.epm.bgmd.util.base.AbstractUtils & CubeUtils_S & CubeUtils$;
            interface CubeUtils extends CubeUtils_T {
            }
        }
        namespace kd.sdk.epm.business.servicehelper{
            interface EbOlapServiceHelper_S {
                /**
                 * 查询返回迭代器，先不做处理
                 * @param queryInfo
                 * @param cubecatalog
                 * @return
                 */
                queryDataReByConn(queryInfo:kd.bos.olap.dataSources.SelectCommandInfo,cubecatalog:string):$.java.util.Map;
            }
            interface EbOlapServiceHelper_C extends EbOlapServiceHelper_S {
                new():EbOlapServiceHelper;
            }
            interface EbOlapServiceHelper$ {
            }
            type EbOlapServiceHelper_T = EbOlapServiceHelper_S & EbOlapServiceHelper$;
            interface EbOlapServiceHelper extends EbOlapServiceHelper_T {
            }
        }
        namespace kd.sdk.epm.common.utils{
            interface Convert_S {
                /**
                 * byte转无符号int
                 *
                 * @param byteValue
                 *         byte值
                 * @return 无符号int值
                 * @since 3.2.0
                 */
                byteToUnsignedInt(byteValue:number):number;
                /**
                 * byte[]转int值
                 *
                 * @param bytes
                 *         byte数组
                 * @return int值
                 * @since 3.2.0
                 */
                bytesToInt(bytes:number[]):number;
                /**
                 * byte数组转long<br>
                 *
                 * @param bytes
                 *         byte数组
                 * @return long值
                 * @since 3.2.0
                 */
                bytesToLong(bytes:number[]):long;
                /**
                 * byte数组转short
                 *
                 * @param bytes
                 *         byte数组
                 * @return short值
                 * @since 3.2.0
                 */
                bytesToShort(bytes:number[]):number;
                convert(type_arg:$.java.lang.Class,value:any):any;
                convert(arg0:$.java.lang.Class,arg1:any,arg2:any):any;
                /**
                 * int转byte
                 *
                 * @param intValue
                 *         int值
                 * @return byte值
                 * @since 3.2.0
                 */
                intToByte(intValue:number):number;
                /**
                 * int转byte数组
                 *
                 * @param intValue
                 *         int值
                 * @return byte数组
                 * @since 3.2.0
                 */
                intToBytes(intValue:number):number[];
                listToMap(list:$.java.util.List,func1:(t:any)=>any):$.java.util.Map;
                listToMap(list:$.java.util.List,func1:(t:any)=>any,func2:(t:any)=>any):$.java.util.Map;
                /**
                 *  将list转为map  如List<Persion> persionList 转为 Map<String,Persion> name2PersionMap
                 * @param list 原数据
                 * @param keyMapper key抽取规则  如  Persion::getName
                 * @param valueMapper value抽取规则  如  Persion::getNumber
                 * @param predicate 过滤条件  如 persion -> persion.getAge() >= 18
                 * @param <K> 返回map中的key的数据类型
                 * @param <V> 返回map中的value的数据类型
                 * @return java.util.Map<K,V>
                 * @create 2021/6/15 17:32
                 */
                listToMap(list:$.java.util.List,func1:(t:any)=>any,func2:(t:any)=>any,predicate3:(t:any)=>boolean):$.java.util.Map;
                /**
                 * long转byte数组<br>
                 *
                 * @param longValue
                 *         long值
                 * @return byte数组
                 * @since 3.2.0
                 */
                longToBytes(longValue:long):number[];
                resultToList(originList:$.java.util.List,func1:(t:any)=>any):$.java.util.List;
                /**
                 * 将List映射为List 如List<Persion> persionList 转为 List<String> nameList
                 * @param originList 原数据
                 * @param mapper 映射规则 如  Persion::getName
                 * @param predicate 过滤条件  如 persion -> persion.getAge() >= 18
                 * @param <T> 原数据类型
                 * @param <R> 返回数据类型
                 * @return java.util.List<R>
                 * @create 2021/6/15 17:36
                 */
                resultToList(originList:$.java.util.List,func1:(t:any)=>any,predicate2:(t:any)=>boolean):$.java.util.List;
                /**
                 * short转byte数组
                 *
                 * @param shortValue
                 *         short值
                 * @return byte数组
                 * @since 3.2.0
                 */
                shortToBytes(shortValue:number):number[];
                /**
                 * 转换为BigDecimal<br>
                 * 如果给定的值为空，或者转换失败，返回null<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @return 结果
                 */
                toBigDecimal(value:any):$.java.math.BigDecimal;
                toBigDecimal(value:any,defaultValue:$.java.math.BigDecimal):$.java.math.BigDecimal;
                toBigInteger(value:any):$.java.math.BigInteger;
                /**
                 * 转换为BigInteger<br>
                 * 如果给定的值为空，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toBigInteger(value:any,defaultValue:$.java.math.BigInteger):$.java.math.BigInteger;
                toBool(value:any):boolean;
                /**
                 * 转换为boolean<br>
                 * String支持的值为：true、false、yes、ok、no，1,0 如果给定的值为空，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toBool(value:any,defaultValue:boolean):boolean;
                toBooleanArray(value:any):boolean[];
                toChar(value:any):string;
                /**
                 * 转换为字符<br>
                 * 如果给定的值为null，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toChar(value:any,defaultValue:string):string;
                toCharArray(value:any):string[];
                /**
                 * 全角转半角
                 *
                 * @param input
                 *         String.
                 * @return 半角字符串
                 */
                toDBC(input:string):string;
                /**
                 * 替换全角为半角
                 *
                 * @param text
                 *         文本
                 * @param notConvertSet
                 *         不替换的字符集合
                 * @return 替换后的字符
                 */
                toDBC(text:string,notConvertSet:$.java.util.Set):string;
                toDouble(value:any):number;
                /**
                 * 转换为double<br>
                 * 如果给定的值为空，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toDouble(value:any,defaultValue:number):number;
                toDoubleArray(value:any):number[];
                toInt(value:any):number;
                /**
                 * 转换为int<br>
                 * 如果给定的值为空，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toInt(value:any,defaultValue:number):number;
                toIntArray(value:any):number[];
                toLong(value:any):long;
                /**
                 * 转换为long<br>
                 * 如果给定的值为空，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toLong(value:any,defaultValue:long):long;
                toLongArray(value:any):long[];
                toNumber(value:any):number;
                /**
                 * 转换为Number<br>
                 * 如果给定的值为空，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toNumber(value:any,defaultValue:number):number;
                toNumberArray(value:any):number[];
                /**
                 * 半角转全角
                 *
                 * @param input
                 *         String.
                 * @return 全角字符串.
                 */
                toSBC(input:string):string;
                /**
                 * 半角转全角
                 *
                 * @param input
                 *         String
                 * @param notConvertSet
                 *         不替换的字符集合
                 * @return 全角字符串.
                 */
                toSBC(input:string,notConvertSet:$.java.util.Set):string;
                toStr(value:any):string;
                /**
                 * 转换为字符串<br>
                 * 如果给定的值为null，或者转换失败，返回默认值<br>
                 * 转换失败不会报错
                 *
                 * @param value
                 *         被转换的值
                 * @param defaultValue
                 *         转换错误时的默认值
                 * @return 结果
                 */
                toStr(value:any,defaultValue:string):string;
                toStrArray(value:any):string[];
            }
            interface Convert_C extends Convert_S {
                new():Convert;
            }
            interface Convert$ {
            }
            type Convert_T = Convert_S & Convert$;
            interface Convert extends Convert_T {
            }
            interface MemberServiceHelper_S {
                /**
                 * SDK专用接口，请勿修改方法及参数
                 * @param modelId 体系id
                 * @param dimNumber 维度编码
                 * @param viewId 视图id
                 * @param numbers 成员编码
                 * @return 成员信息
                 */
                queryByNums(modelId:long,dimNumber:string,viewId:long,numbers:$.java.util.Set):$.java.util.Map;
            }
            interface MemberServiceHelper_C extends MemberServiceHelper_S {
                new():MemberServiceHelper;
            }
            interface MemberServiceHelper$ {
            }
            type MemberServiceHelper_T = MemberServiceHelper_S & MemberServiceHelper$;
            interface MemberServiceHelper extends MemberServiceHelper_T {
            }
            interface QFBuilder_S {
                newQFilter():QFBuilder;
            }
            interface QFBuilder_C extends QFBuilder_S {
                new():QFBuilder;
                new(filter:$.kd.bos.orm.query.QFilter):QFBuilder;
                new(field:string,qc:string,val:any):QFBuilder;
            }
            interface QFBuilder$ {
                add(filter:$.kd.bos.orm.query.QFilter):this;
                add(...filters:$.kd.bos.orm.query.QFilter[]):this;
                add(filters:$.java.util.List):this;
                add(field:string,qc:string,value:any):this;
                and(field:string,qc:string,val:any):this;
                clear():void;
                getFilters():$.java.util.List;
                or(qFilter:$.kd.bos.orm.query.QFilter):this;
                or(field:string,qc:string,val:any):this;
                remove(field:string):this;
                toArray():$.kd.bos.orm.query.QFilter[];
                toArrays():$.kd.bos.orm.query.QFilter[];
                toFilter():$.kd.bos.orm.query.QFilter;
                toList():$.java.util.List;
            }
            type QFBuilder_T = QFBuilder_S & QFBuilder$;
            interface QFBuilder extends QFBuilder_T {
            }
            interface StringUtils_S {
                asList(...texts:string[]):$.java.util.List;
                equals(str:$.kd.bos.dataentity.entity.ILocaleString,str2:$.kd.bos.dataentity.entity.ILocaleString):boolean;
                /**
                 * 判断字符串是否相等，包括了对比双方为null的状况
                 */
                equals(str:string,str2:string):boolean;
                /**
                 * 描述：判断两个多语言对象是否相等（都为空相等，数据不同不相等）
                 * @param str 多语言对象1
                 * @param str2 多语言对象2
                 * @param ignBlank 是否忽略空格
                 * @return 是否相等
                 */
                equals(str:$.kd.bos.dataentity.entity.ILocaleString,str2:$.kd.bos.dataentity.entity.ILocaleString,ignBlank:boolean):boolean;
                /**
                 * 描述：判断字符串是否相等，包括了对比双方为null的状况
                 * @param str 字符串1
                 * @param str2 字符串1
                 * @param ignBlank 是否忽略空格
                 * @return 是否相等
                 */
                equals(str:string,str2:string,ignBlank:boolean):boolean;
                equalsIgnoreCase(str:string,str2:string):boolean;
                firstUpperCase(str:string):string;
                /**
                 * 描述：如果为空则返回空字符串
                 * @param str 字符串1
                 * @return 返回字符串
                 */
                getBlank(str:string):string;
                include(str:string,text:string):boolean;
                isBase64Encode(value:string):boolean;
                /**
                 * 描述：判断是否是字符串类型，null也算
                 * @param value 数据对象
                 * @return 是否是空字符串
                 */
                isBlankString(value:any):boolean;
                isDate(dateTime:string):Date;
                isEmpty(str:string):boolean;
                isEmptyArray(...str:string[]):boolean;
                isEmptyArrays(...strings:string[]):boolean;
                isNotEmpty(str:string):boolean;
                isNumeric(str:string):boolean;
                join(array:any[],separator:string):string;
                join(array:$.java.util.Collection,separator:string):string;
                notEquals(str:$.kd.bos.dataentity.entity.ILocaleString,str2:$.kd.bos.dataentity.entity.ILocaleString):boolean;
                notEquals(str:string,str2:string):boolean;
                notEquals(str:$.kd.bos.dataentity.entity.ILocaleString,str2:$.kd.bos.dataentity.entity.ILocaleString,ignBlank:boolean):boolean;
                notEquals(str:string,str2:string,ignBlank:boolean):boolean;
                removeBlank(str:string):string;
                replace(str:string,...args:any[]):string;
                replace(str:string,replaceArgs:$.java.util.HashMap):string;
                split(str:string,separatorChars:string):string[];
                substring(str:string,len:number):string;
                toNoEmptyString(value:any):string;
                toTrimString(value:any):string;
            }
            interface StringUtils_C extends StringUtils_S {
                new():StringUtils;
            }
            interface StringUtils$ {
            }
            type StringUtils_T = StringUtils_S & StringUtils$;
            interface StringUtils extends StringUtils_T {
            }
            interface LogStats_S {
                readonly LINE_BREAK_MARK:string;
            }
            type LogStats_ST = $.java.io.Serializable & LogStats_S;
            interface LogStats_C extends LogStats_ST {
                new(tag:string):LogStats;
            }
            interface LogStats$ {
                add(logStr:string):void;
                add(logStr:string,showTime:boolean):void;
                addInfo(logStr:string):void;
            }
            type LogStats_T = $.java.io.Serializable & LogStats_S & LogStats$;
            interface LogStats extends LogStats_T {
            }
        }
        namespace kd.sdk.epm.control.eums{
            enum ControlResultEnum {
                DONTCONTROL,
                PASS,
                BEYOND
            }
        }
        namespace kd.sdk.epm.control.impl.model{
            interface ControlResult_S {
                /**
                 * 将微服务的对象转换为SDK对象
                 * @param result
                 * @return
                 */
                caseTo(result:any):ControlResult;
            }
            type ControlResult_ST = $.java.io.Serializable & ControlResult_S;
            interface ControlResult_C extends ControlResult_ST {
                new():ControlResult;
            }
            interface ControlResult$ {
                getCode():string;
                getResult():kd.sdk.epm.control.eums.ControlResultEnum;
                getWarningResult():$.java.util.Map;
            }
            type ControlResult_T = $.java.io.Serializable & ControlResult_S & ControlResult$;
            interface ControlResult extends ControlResult_T {
            }
        }
        namespace kd.sdk.epm.ebBusiness.sql.util{
            interface DateTimeUtils_S {
                addDate(dDate1:Date,dDate2:Date):Date;
                addDay(dDate:Date,iNbDay:long):Date;
                addDuration(dDate:Date,iNbYear:number,iNbMonth:number):Date;
                addDuration(dDate:Date,iNbYear:number,iNbMonth:number,iNbDay:number):Date;
                addDuration(dDate:Date,iNbYear:number,iNbMonth:number,iNbDay:number,iNbHour:number):Date;
                addDuration(dDate:Date,iNbYear:number,iNbMonth:number,iNbDay:number,iNbHour:number,iNbMinute:number):Date;
                addDuration(dDate:Date,iNbYear:number,iNbMonth:number,iNbDay:number,iNbHour:number,iNbMinute:number,iNbSecond:number):Date;
                addHour(dDate:Date,iNbHour:long):Date;
                addMinute(dDate:Date,iNbMinute:long):Date;
                addMonth(dDate:Date,iNbMonth:number):Date;
                addSecond(dDate:Date,iNbSecond:long):Date;
                addYear(dDate:Date,iNbYear:number):Date;
                dayAfter(dt:Date,dt1:Date):boolean;
                dayBefore(dt:Date,dt1:Date):boolean;
                dayEquals(dt:Date,dt1:Date):boolean;
                daysOfMonth(year:number,month:number):number;
                defaultDateString(d:Date):string;
                defaultDateString(d:Date,timezone:$.java.util.TimeZone):string;
                emailDate(d:Date):string;
                emailDate(d:Date,timezone:$.java.util.TimeZone):string;
                format(d:Date):string;
                format(d:Date,fmt:string):string;
                format(d:Date,timezone:$.java.util.TimeZone):string;
                format(d:Date,fmt:string,timezone:$.java.util.TimeZone):string;
                format(d:Date,fmt:string,timezone:$.java.util.TimeZone,locale:$.java.util.Locale):string;
                formatDate(d:Date):string;
                formatDate(d:Date,timezone:$.java.util.TimeZone):string;
                formatTime(d:Date):string;
                formatTime(d:Date,timezone:$.java.util.TimeZone):string;
                getMonth(d:Date):number;
                getQuarter(date:Date):number;
                isLeap(year:number):boolean;
                parseDate(s:string):Date;
                parseDate(s:string,fmt:string):Date;
                parseDate(s:string,fmt:string,timezone:$.java.util.TimeZone):Date;
                parseDate(s:string,fmt:string,timezone:$.java.util.TimeZone,locale:$.java.util.Locale):Date;
            }
            interface DateTimeUtils_C extends DateTimeUtils_S {
                new():DateTimeUtils;
            }
            interface DateTimeUtils$ {
            }
            type DateTimeUtils_T = DateTimeUtils_S & DateTimeUtils$;
            interface DateTimeUtils extends DateTimeUtils_T {
            }
        }
    }
}
export {};